Problem LinkAuthor: Prateek Tester: Pawel Kacprzak and Misha Chorniy Editorialist: Bhuvnesh Jain DifficultyMEDIUM PrerequisitesProduct Trick, MeetinMiddle ProblemYou are given an array $A$. You are required to find the number of subsequences of $A$ such that product of the elements of the subsequence is less than or equal to $K$. Quick ExplanationCalculate all possible subsets product for 2 halves of the array. Apply meet in the middle to find the overall answer. ExplanationFirst of all we count the number of subsequences of any array of size $n$. For every element there are 2 choices, either consider that element into the subsequence or not. Thus the total number of subsequence is $2^n$. This also includes 2 trival case, the empty subsequence where all the elements are considered and the full subsequence, where all the elements are considered. Subtask 1 This subtask can be easily solved using brute force by iterating over all the subsets and checking whether their product of elements is less than or equal to $O(K)$ or not. This will take complexity $O(n * 2^n)$ which is too slow for larger subtask. Below is the pseudo code for iterating over all subsets and getting the elemnts present in each element.
Subtask 2 Solution 1 Before reading the solution outlined below, I request you to go throught this editorial on Meet in the middle. After going throught the first example in the above link, we can get some idea, how we are going to approach this question. We simply find the product of all possible subsets after diviing the array into 2 parts. Since each part be of maximum size $15$, the above procedure will be feasible. The complexity of this precalculation takes $O(2 * (n/2) * 2^{n/2}) = O(n * 2^{n/2})$, which would easily fit into our time limit. Now, we simply sort the above 2 arrays. Let us call these arrays, $B$ and $C$. Then, consider all the elemts of $B$ one by one and check how many elements of $C$ can give product less than or equal to $K$, with the given element. The sum over all the elements is the required answer. For finding the number of elements in $C$, we can use binary search to find out how many number are less than $\frac{K}{B[i]}$. This is because we want $B[i] * x <= K$, i.e. $x \leq \frac{K}{B[i]}$, where $x \in C$ Solution 2 This solution is specific for this problem only. Here we will use the fact that product of 20 distinct numbers will always exceed ${10}^{18}$ as the smallest product of 20 distinct numbers is $factorial(20) \approx 2.43 * {10}^{18}$. So, we simply do a recursive procedure and try to solve the problem. Here at each step of the recursion, we have 2 choices i.e. either to include the object into the subsequence or not. Doing it naively will give the same result as brute force and give time limit exceeded. Also, there are almost no overlapping subproblems as well, so dynamic programming cannot be applied. So, we basically cut down the recursion depth and make it work almost as fast as the above solution, (sometime even faster than the above solution) using the following tricks :
The above recursive solution can be found in the Editorialist 2nd solution. Caveats All the above algorithms will work correctly, just that there can be issues with overflows, due to the constraints on the numbers in the question. For example, multiplying 2 number as large as ${10}^{10}$ will easily result in overflow in most languages, if not using big integer arithmetic support. The editorialist has used big integer library support in python in order to avoid any issues but the same can be handled in C, C++, Java etc using the below function :
Thus the product of 2 numbers should be taken only when it is safe to multiply them else it can be concluded that the product will exceed $K$ (maximum value of $K$ in the problem is given as ${10}^{18}$). Time Complexity$O(n * 2^{n/2})$ Solution Links
This question is marked "community wiki".
asked 18 May '17, 13:48

Simple recursion can solve this problem. Reducing array values into Log(Value) will cause the problem to change from Product Subsequence to Sum subsequence to prevent long overflow and reducing heavy multiplication. Counting number of ones and Simple Recursion without ONES with optimized Breaking from recursion does the trick. Final answer can be calculated by using Simple Combination Logics which you can see here Java 0.09s: AC Code Link answered 18 May '17, 16:24

I need editorial for GPD, want to know how to solve GPD. answered 18 May '17, 15:23

I solved the problem with method explained in subtask2 solution1 ie Meet in the Middle . It gave the correct answer only when i sort the input array but i am unable to find out why we need to sort input array ? Can someone please explain this . Here is my solution
answered 18 May '17, 18:42

@shivank01 as Ai is too large 10^18 and you are taking product of a whole subset eventually you would exceed the limit lets say there are 10 elements of 10^18 s the product would be 10^180 then integer overflow happens you should have just use the condition if your product>=k at any point break else if you move to the end of loop successfully just increase the count, and ans will be count1,that is don't count empty subset this will allow you to fetch 30 points only. Hope this helps! answered 18 May '17, 19:57

Can anyone tell me what's wrong with my code? It's giving wa in 8th test case.. https://ideone.com/XMBnDr https://www.codechef.com/viewsolution/13629225 answered 18 May '17, 16:07

can anyone please tell what is wrong in my code https://www.codechef.com/viewsolution/13580088 it is giving WA in two test cases answered 18 May '17, 16:15
and got AC in this https://www.codechef.com/viewsolution/13580236 just a language change but logic is same
(18 May '17, 16:23)

Can anyone tell me what's wrong with this solution, https://www.codechef.com/viewsolution/13538559 .I didn't get even 30pts for this.I have done the same as the subtask 1 of this editorial. answered 18 May '17, 17:39

can anybody explain how duplicates are handled in 2nd approach ? answered 18 May '17, 21:06

@admin I guess there's a problem . SHORT Same code shows accepted during the contest but now in the practice arena it shows TLE. LONG I submitted my solution during the contest . Got AC answers in subtask #1 (30 points) and in subtask #2 , all tasks were AC except two tasks numbered 1,8. But now when i submit the same solution (code) in the practice arena ... mentioned in this post . I get a TLE for each and every task . Do u consider this as a problem on ur part ? LINKS my solution during contest https://www.codechef.com/viewsolution/13621620 same solution after the contest(in practice arena)  https://www.codechef.com/viewsolution/13631281 answered 18 May '17, 21:54
You should try again
(18 May '17, 23:40)
Now it gives different result, very weird shouldn't have happened
(18 May '17, 23:53)

Pseudo code for Subtask 1 will give you a TLE if you don't perform a raincheck i.e. a[i]<K. answered 18 May '17, 23:27

can anyone tell me what is the wrong with this solution,https://www.codechef.com/viewsolution/13635976 .i do same as the editorials solution 1. answered 19 May '17, 19:00

in the editorial it is said that we can sort the array and remove dublcates....after removing dublicates how will we handle the answer.. answered 19 May '17, 19:49

I got all testcases accepted in 0.06 sec but got TLE for task 8. Can anyone tell whats wrong with my code? https://www.codechef.com/viewsolution/13542837 . answered 19 May '17, 19:54

I need editorial for long sandwich question please post asap answered 19 May '17, 20:07

https://www.codechef.com/viewsolution/13636503 Can somebody point out the mistake in my code, am getting WA in 2 subtasks. I followed the steps told in solution1. Thanks in advance. :) answered 19 May '17, 20:16

https://www.codechef.com/viewsolution/13636745 solved using dp and recursion :) can anyone explain the log and oc trimming solutions plz ...thanks n advance :) answered 19 May '17, 20:32

Regarding the 2nd subtask, after splitting, is it necessary to apply binary search? If yes, then why? answered 20 May '17, 11:37

@shivank01 here is your AC code for the first subtask,https://www.codechef.com/viewsolution/13639615 . For the second subtask you can view my code involving meet in the middle algorithm, https://www.codechef.com/viewsolution/13639438 answered 20 May '17, 11:52

https://www.codechef.com/viewsolution/13639790 answered 20 May '17, 12:21

For large dataset, i sorted the array.For each subset, i started with largest number to check whether the product is greater than k. Every number has a bit position between 1<=pos<=30 Whenever we get any number which makes the product greater than k,we can increment the counter to the point where that bit position changes from 1 to 0. By this approach i got all test cases accepted in 0.05 sec except test case #8. Can anyone figure it out what's the issue with it? https://www.codechef.com/viewsolution/13542837 answered 21 May '17, 12:40

Can anyone tell me what is wrong with the following code. I have tried several things and always same cases are giving wrong answer. answered 25 May '17, 00:28

I think editorialist should comment his code for better understanding. answered 25 May '17, 20:10

https://www.codechef.com/viewsolution/13791336 this is passing subtask 1 but not the subtask 2 though I have used meet in the middle algorithm. Can somebody please pointout problem in my code. answered 26 May '17, 19:31

I am getting a TLE in test case 8. I have used simple backtracking by calculating products and checking if the product exceeds K and also considering overflows. Please correct me if I am wrong but I feel complexity remains the same if we log the array elements and consider the sum of number to be less than K. So why is that solution running under time? Doesn't multiplication and addition take same time on modern processors? Here's my solution: https://www.codechef.com/viewsolution/13579609 Thanks! answered 26 May '17, 22:13

I implemented the solution 1 of subtask 2 still I'm getting WA in some test cases of subtask 2(subtask 1 works fine) If anyone could look for mistakes...help appreciated. Here is my solution: answered 29 May '17, 03:04

Giving wrong answer ? answered 26 Dec '17, 11:14
